/* Statistics gathered for report (per-thread, per-process, and global). */
typedef struct {
  double cliques;			/* total number of cliques */
  double max_memory;			/* maximum clique memory usage */
  double local_fetch;			/* cliques taken from other threads */
  double local_bytes;			/* bytes of data from other threads */
  double remote_fetch;			/* cliques taken from remote processes */
  double remote_bytes;			/* bytes of data from remote processes */
  double compute_time;			/* time finding cliques */
  double fetch_time;			/* time fetching from remote processes */
  double request_time;			/* time handling remote requests */
  double idle_time;			/* time waiting for other processes */
  double init_time;			/* initialization time */
  double enum_time;			/* clique_enumerate time */
  double read_time;			/* graph_read time */
  double root_time;			/* init_clist time */
  double output_time;			/* clique output time */
} rstats_t;

extern rstats_t *rstats;		/* per-thread statistics */
extern double sample_time;		/* sampling interval */
extern int clique_breakdown;		/* print clique counts by size */

/* Run-time summary statistics. */
extern void rstats_init(void);
extern void rstats_end(void);

/* Run-time sampling statistics. */
extern void sample_check(double current_time, int id);
extern void sample_write(int id);

/* Clique size binning. */
extern void clique_bin(int size);

/* Timing function. */
extern double dclock(void);
